# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List
from pydantic.v1 import StrictStr, Field, BaseModel, Field, conlist 
from lusid.models.group_reconciliation_summary import GroupReconciliationSummary

class GroupReconciliationRunResponse(BaseModel):
    """
    GroupReconciliationRunResponse
    """
    reconciliation_summaries: conlist(GroupReconciliationSummary) = Field(..., alias="reconciliationSummaries", description="One summary record for each of the \"Holding\" | \"Transaction\" | \"Valuation\" reconciliations performed")
    __properties = ["reconciliationSummaries"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GroupReconciliationRunResponse:
        """Create an instance of GroupReconciliationRunResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in reconciliation_summaries (list)
        _items = []
        if self.reconciliation_summaries:
            for _item in self.reconciliation_summaries:
                if _item:
                    _items.append(_item.to_dict())
            _dict['reconciliationSummaries'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GroupReconciliationRunResponse:
        """Create an instance of GroupReconciliationRunResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GroupReconciliationRunResponse.parse_obj(obj)

        _obj = GroupReconciliationRunResponse.parse_obj({
            "reconciliation_summaries": [GroupReconciliationSummary.from_dict(_item) for _item in obj.get("reconciliationSummaries")] if obj.get("reconciliationSummaries") is not None else None
        })
        return _obj
